
/*
TASK: table
LANG: C++
*/

#include <cstdio>
#include <algorithm>
using namespace std;

const int MAX = 64;

const int dx[] = {-1, 1, 0, 0};
const int dy[] = {0, 0, -1, 1};

int N, M;
int a[MAX][MAX];
int b[MAX][MAX];
int c[MAX][MAX];

void read()
{
    scanf("%d %d", &N, &M);
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j)
            scanf("%d", &a[i][j]);
    
    if (M > N)
    {
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < M; ++j)
                c[i][j] = a[i][j];
        swap(N, M);
        for (int i = 0; i < N; ++i)
            for (int j = 0; j < M; ++j)
                a[i][j] = c[j][i];
    }
}

int rec(int x, int y)
{
    if (y == M)
        return rec(x + 1, 0);
    if (x == N)
    {
        for (int i = 0; i < M; ++i)
            if (b[x - 1][i] != a[x - 1][i])
                return 0;
        return 1;
    }
    
    int res = 0;
    for (int k = 0; k < 3; ++k)
    {
        for (int d = 0; d < 4; ++d)
        {
            int nx = x + dx[d];
            int ny = y + dy[d];
            if (nx < 0 || nx >= N || ny < 0 || ny >= M)
                continue;
            b[nx][ny] += k;
            if (b[nx][ny] >= 3)
                b[nx][ny] -= 3;
        }
        bool ok = true;
        if (x - 1 >= 0)
            if (b[x - 1][y] != a[x - 1][y])
                ok = false;
        c[x][y] = k;
        if (ok)
            res += rec(x, y + 1);
        for (int d = 0; d < 4; ++d)
        {
            int nx = x + dx[d];
            int ny = y + dy[d];
            if (nx < 0 || nx >= N || ny < 0 || ny >= M)
                continue;
            b[nx][ny] -= k;
            b[nx][ny] += 3;
            if (b[nx][ny] >= 3)
                b[nx][ny] -= 3;
        }
    }
    return res;
}

void solve()
{
    printf("%d\n", rec(0, 0));
}

int main()
{
    read();
    solve();
    return 0;
}
