/*
TASK:mirrors
LANG:C++
*/
#include <iostream.h>
#include <stdio.h>
#include <math.h>
#define eps 0.000000001
using namespace std;
struct point
{
double x,y;
};
struct vect
{
double dx,dy,x,y;
};
struct comb
{
point p;
double angle,dist;
int yesno;
};
point a,b;
vect p[16];

inline comb operator + (comb a,comb b)
{
comb t;
t=a;
t.angle=(a.angle+b.angle)/2.0;
return t;       
}
inline point operator + (vect a, point b)
{
point t;
t.x=b.x+a.dx;
t.y=b.y+a.dy;
return t;
}
inline vect operator * (vect a, double k)
{
vect t;
t.x=a.x;
t.y=a.y;
t.dx=a.dx*k;
t.dy=a.dy*k;
return t;
}
inline point mpoint(vect a)
{
point t;
t.x=a.x;
t.y=a.y;
return t;       
}
inline point mpoint2(vect a)
{
point t;
t.x=a.x+a.dx;
t.y=a.y+a.dy;
return t;       
}


double ccw(point a,point b, point c)
{
return (b.y-c.y)*a.x+(c.y-a.y)*b.x+(a.y-b.y)*c.x;
}
inline double dist (point a, point b)
{
return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}
inline point cross(vect a, vect p)
{
double t;
t= (a.dx*(p.y-a.y)+a.dy*(a.x-p.x) )/(p.dx*a.dy-p.dy*a.dx);
point m;
m.x=p.x;
m.y=p.y;
m=(p*t)+m;
return m;       
}
vect mirror(vect a,vect p)
{
double t;
point m;
m=cross(a,p);
vect d;
d.x=a.x;
d.y=a.y;
d.dx=-p.dy;
d.dy=p.dx;
point h1,h2;
h1=cross(d,p);
h2.x=h1.x+(m.x-h1.x)*2.0;
h2.y=h1.y+(m.y-h1.y)*2.0;
d.x=h2.x;
d.y=h2.y;
if (fabs(dist(mpoint(p),m))<eps) 
    {
    d=a*(-1);
    d.x=m.x;
    d.y=m.y;
    return d;
    }
t=fabs(ccw(mpoint(a),m,mpoint(p))/dist(mpoint(p),m));
double l;
l=t/sqrt(d.dx*d.dx+d.dy*d.dy);
d=d*l;
point a1;
a1=d+h2;
d.x=m.x;
d.y=m.y;
d.dx=a1.x-m.x;
d.dy=a1.y-m.y;
/*printf("M(%.6f %.6f\n",m.x,m.y);
printf("H1(%.6f %.6f)\n",h1.x,h1.y);
printf("H2(%.6f %.6f)\n",h2.x,h2.y);
printf("A1(%.6f %.6f)\n",a1.x,a1.y);
printf("dist=%.6f \n",t);
printf("vect(x=%.6f y=%.6f dx=%.6f dy=%.6f )\n",d.x,d.y,d.dx,d.dy);*/
return d;
}   
int n;  
inline void calc_perm (comb a,point &dest,double &rast, int &yesno)
{
vect d;
d.x=a.p.x;     
d.y=a.p.y;
d.dx=cos(a.angle);
d.dy=sin(a.angle);
//printf("vect(x=%.6f y=%.6f dx=%.6f dy=%.6f )\n",d.x,d.y,d.dx,d.dy);
int i;
double l;
int used[20];
for(i=0;i<20;i++) used[i]=0;
vect v[20];
int v1[20];
int br=0;
double min=100000000;
int k=-1,num=0;
while(1)
{
    br=0;
    min=100000000;
    k=-1;
    for(i=0;i<n;i++)
    if (used[i]==0)
    {
  //  printf("p[%d] (x=%.6f y=%.6f dx=%.6f dy=%.6f )\n",i,p[i].x,p[i].y,p[i].dx,p[i].dy);                   
    point pp;
    l=ccw(mpoint(d),mpoint(p[i]),mpoint2(p[i]));
    if(fabs(ccw(mpoint(d),mpoint(p[i]),mpoint2(p[i])))<
       fabs(ccw(mpoint2(d),mpoint(p[i]),mpoint2(p[i])))) continue;
    //printf("ccw[%d]=%.6f \n",i,l);
    if (fabs(l)<eps) {
                     v[br]=d;
                     v1[br++]=i;
               //      printf("! %d \n",i);
                     }
                else{
                     if (l>0) {
                         v[br]=mirror(d,p[i]);
                   //      printf("(%.6f,%.6f) in (%.6f,%.6f) , (%.6f,%.6f)\n",
//                         v[br].x, v[br].y ,p[i].x ,p[i].y, p[i].x+p[i].dx, p[i].y+p[i].dy);
                         v1[br++]=i;
                         if 
                         (!(
                             (
                             ((p[i].x<=v[br-1].x) && (v[br-1].x<=(p[i].x+p[i].dx))) ||
                             ((p[i].x>=v[br-1].x) && (v[br-1].x>=(p[i].x+p[i].dx))) 
                             )&&
                             (
                             ((p[i].y<=v[br-1].y) && (v[br-1].y<=(p[i].y+p[i].dy))) ||
                             ((p[i].y>=v[br-1].y) && (v[br-1].y>=(p[i].y+p[i].dy))) 
                             )
                         )) 
                            {br--;
                            //printf("DELETED\n");
                            }
                         }
//                         printf("x< x> y< y>")
                    }
    }
    
    for(i=0;i<br;i++)
     if ((v[i].dx*v[i].dx+v[i].dy*v[i].dy)<min)
      {
      min=v[i].dx*v[i].dx+v[i].dy*v[i].dy;
      k=i;
      }
    if (k==-1)
    {
    yesno=0;
    return;
    }  
   // printf("minavame prez %d\n",v1[k]);
    used[v1[k]]=1;
    d=v[k];
  //  printf("new vect(x=%.6f y=%.6f dx=%.6f dy=%.6f )\n",d.x,d.y,d.dx,d.dy);
    num++;
    if (num==n)
    {
    yesno=1;
    rast=fabs(ccw(mpoint(d),dest,mpoint2(d))/dist(mpoint(d),mpoint2(d)));
    return;
    }
    
}    

}
inline int cmp (comb a, comb b)
{
if ((a.yesno==b.yesno) && fabs(a.dist-b.dist)<eps) return a.angle<b.angle;    
if (a.yesno==b.yesno) return a.dist<b.dist;
 return a.yesno>b.yesno;     
}
comb kombs[10200];
int nkomb;
int main()
{
 scanf("%d",&n);
 scanf("%lf%lf",&a.x,&a.y)   ;
 scanf("%lf%lf",&b.x,&b.y)   ;
 int i;
 double ax,ay;
 for(i=0;i<n;i++) {
                  scanf("%lf%lf%lf%lf",&p[i].x,&p[i].y,&ax,&ay);
                  p[i].dx=ax-p[i].x;                  
                  p[i].dy=ay-p[i].y;
                //  printf("p[%d] (x=%.6f y=%.6f dx=%.6f dy=%.6f )\n",i,p[i].x,p[i].y,p[i].dx,p[i].dy);  
                  }
 nkomb=360;
 for(i=0;i<nkomb;i++)
 {                  
 kombs[i].p.x=a.x;
 kombs[i].p.y=a.y;
 kombs[i].angle=i*M_PI/180.0;
 calc_perm(kombs[i],b,kombs[i].dist,kombs[i].yesno);
 }
 int iters=0,br,j;
 while (iters!=40)
 {
 sort(kombs,kombs+nkomb,cmp);
 for(i=0;i<(nkomb-1);i++)
 if (fabs(kombs[i].angle-kombs[i+1].angle)<eps)
 {
 kombs[i]=kombs[nkomb-1];
 nkomb--;
 }
 sort(kombs,kombs+nkomb,cmp);
 /*printf("wave %d \n\n\n",iters);
 for(i=0;i<70;i++)
 {
 printf("%d -> angle=%.6f dist==%.6f yesno=%d\n",i,kombs[i].angle/M_PI*180.0,kombs[i].dist,kombs[i].yesno);
 }*/
 nkomb=70;
 br=nkomb;
 for(i=0;i<nkomb;i++)
  for(j=i+1;j<nkomb;j++)
   {
   kombs[br]=kombs[i]+kombs[j];  
   calc_perm(kombs[br],b,kombs[br].dist,kombs[br].yesno);   
   br++;                 
    }
 nkomb=br;
 iters++;
 }
 if (kombs[0].yesno==0) printf("NO\n");
 else
 {
     printf("YES\n%.6f\n",kombs[0].angle/M_PI*180.0);
 }
 return 0;   
    
}
