/*
TASK:mirrors
LANG:C++
*/
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <algorithm>
#include <utility>
#include <numeric>
#include <functional>

using namespace std;

#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define PI pair<int,int>
#define PD pair<double,double>
#define VI vector<int>
#define VD vector<double>
#define LL long long
#define PB push_back
#define MP make_pair
#define SZ size()
#define ALL(v) (v).begin(),(v).end()
#define x first
#define y second
#define ULL unsigned LL
#define ABS(x) (((x)>0)?(x):(-(x)))
#define sign(x) (((x)>0)-((x)<0))
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))
#define PQ priority_queue

#define Time (double)clock()/CLOCKS_PER_SEC
#define pause system("pause")

#define MAXN 1024

int N,M;
PD start,end;
struct mirr{ PD A,B; double angle; };
mirr m[15];
int ord[15];
#define DBG 1

#define EPS 1e-12

inline double cp(const PD &A,const PD &B,const PD &C)
{
       double dx1=B.x-A.x,dy1=B.y-A.y,dx2=C.x-A.x,dy2=C.y-A.y;
       return dx1*dy2-dx2*dy1;
}

inline PD intersect(const PD &A,const PD &B,const PD &C,const PD &D)
{
       double s1=cp(A,C,D),s2=s1+cp(C,B,D);
       if (fabs(s2)<EPS) return MP(1e100,1e100);
       return MP( A.x+(B.x-A.x)*s1/s2 , A.y+(B.y-A.y)*s1/s2 );
}
inline bool isin(const PD &X,const PD &A,const PD &B)
{
       return ( X.x>=MIN(A.x,B.x) && X.y>=MIN(A.y,B.y) && X.x<=MAX(A.x,B.x) & X.y<=MAX(A.y,B.y) );
}

double mincp;
int gowhere(PD pnt,double ag,int at)
{
    PD pnt2=MP(pnt.x+cos(ag),pnt.y+sin(ag));
    double tmp;
    if (at==N)
     {
             // cout<<"       --reached final miror! "<<cp(pnt,pnt2,end)<<"\n";
              //if (fabs(cp(pnt,pnt2,end))<EPS*2.) { reached=1; return 0; }
              tmp=cp(pnt,pnt2,end);
              mincp=min(mincp,fabs(tmp));
              if (tmp>0)
                 {  
                         //   cout<<"                   and  should go left\n";
                            return -1;
                 }
             // cout<<"                   and  should go right\n";
              return 1;
     }
    int in=ord[at];
    PD X;
   // cout<<"       --go where "<<in<<" - "<<pnt.x<<" "<<pnt.y<<" ; "<<pnt2.x<<" "<<pnt2.y<<" ; "<<ag/M_PI*180.<<"\n";
    if (cp(m[in].A,m[in].B,pnt)<-EPS) 
     {
                                //     cout<<"                          comginf from the back!\n";
                                     if (!at) return 0;
                                     int prev=ord[at-1];
                                     X=intersect(m[in].A,m[in].B,m[prev].A,m[prev].B); 
                                     if (X.x==1e100 && X.y==1e100) 
                                      {
                              //                      cout<<"                        nespasqemo...\n";
                                                    return 0;
                                      }
                                     if (!isin(X,m[prev].A,m[prev].B)) 
                                                                    return 0;
                                     if (cp(X,pnt,m[in].A)>EPS)
                                      {
                                                        //    cout<<"                           ==should go left\n";
                                                            return -1;
                                      }
                          //          cout<<"                           ==should go right\n";
                                    return 1;
                                    // return 0;
     }
    X=intersect(m[in].A,m[in].B,pnt,pnt2);
 //   cout<<"                  intersect at "<<X.x<<" "<<X.y<<endl;
    if (X.x==1e100 && X.y==1e100)
     {
       //          cout<<"                         parralel mirrors!!\n";
                 tmp=cp(pnt,pnt2,m[in].A);
                 if (tmp>EPS)
                  { // cout<<"                 should go left\n"; return -1;
                  }
                 else
                  if (tmp<-EPS)
                   {
                 //    cout<<"                  shgould go right\n";
                     return 1;
                   }
                 X=MP((m[in].A.x+m[in].B.x)/2.,(m[in].A.y+m[in].B.y)/2.);
     }
    if (cp(pnt,m[in].A,X)<-EPS) 
     {  
                   //         cout<<"                 should go left\n";
                            return -1;
     }
    if (cp(pnt,m[in].B,X)>EPS) 
     {
                   //        cout<<"                  shgould go right\n";
                           return 1;
     }
     
    double normal=m[in].angle-M_PI/2.;
    double an2=normal*2.-ag+M_PI;
    //cout<<"                 normal = "<<normal*180./M_PI<<" an2 = "<<an2*180./M_PI<<endl;
    return gowhere(X,an2,at+1)*(-1);
}

const int TLE=0.65*(double)CLOCKS_PER_SEC;

int main()
{
    //freopen("","r",stdin); freopen("","w",stdout);
    scanf("%d",&N);
    scanf("%lf%lf%lf%lf",&start.x,&start.y,&end.x,&end.y);
    Repi(N)
     {scanf("%lf%lf%lf%lf",&m[i].A.x,&m[i].A.y,&m[i].B.x,&m[i].B.y);
      m[i].angle=atan2(m[i].B.y-m[i].A.y,m[i].B.x-m[i].A.x);
   //   cout<<i<<" : "<<m[i].A.x<<" "<<m[i].A.y<<" "<<m[i].B.x<<" "<<m[i].B.y<<" -> "<<m[i].angle/M_PI*180.<<endl;
     }
    
    
    Repi(N) ord[i]=i;
    do
    {
       //     cout<<" ord: "; Repi(N) cout<<ord[i]<<" "; cout<<endl;
            double l=atan2( m[ord[0]].A.y-start.y,m[ord[0]].A.x-start.x)-EPS;
            double r=atan2( m[ord[0]].B.y-start.y,m[ord[0]].B.x-start.x)+EPS;
      //      cout<<" l/r = "<<l/M_PI*180.<<" "<<r/M_PI*180.<<endl;
            if (l>0 && r<0) r+=2.*M_PI;
            double m; mincp=1e100;
            while (l+EPS<r)
             {
                  m=(l+r)*.5;
         //         cout<<"    "<<l/M_PI*180.<<" "<<r/M_PI*180.<<" -  try  "<<m/M_PI*180.<<" :\n";
                  int dir=gowhere(start,m,0);
        //          cout<<"    direction   "<<dir<<endl;
                  if (dir<0) l=m; else if (dir>0) r=m;
                  else break;
             }
            if (mincp<1e-7)
             { 
               while (l<0) l+=2*M_PI; while (l>M_PI*2.) l-=2*M_PI;
               printf("YES\n%.6lf\n",l*180./M_PI);
               exit(0);
             }
     //       cout<<"\n\n\n";
            if (clock()>TLE) { break; }
     } while (next_permutation(ord,ord+N));
    printf("NO\n");
    return 0;
}
