/*
TASK: mirrors
LANG: C++
*/
#include <cstdio>
#include <cmath>
#include <ctime>
#define SQR(a) ((a)*(a))

typedef struct point {
        double x,y;
        } point;

inline double ori(point a, point b, point c)
{return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);}

inline void norm(point *a)
{
     double l;
     l = sqrt(SQR(a->x)+SQR(a->y));
     a->x /= l;
     a->y /= l;
}

/*point rot(point a, double l)
{
      point r;
      r.x = cos(l)*a.x - sin(l)*a.y;
      r.y = sin(l)*a.x + cos(l)*a.y;
      return r;
}*/

int n;
point a,b;
point list[12][2];
double b_res = (1<<25), b_ang;
char fl;
int used;

void input()
{
     int i;
     scanf("%d",&n);
     scanf("%lf%lf%lf%lf",&a.x,&a.y,&b.x,&b.y);
     for (i=0;i<n;++i) scanf("%lf%lf%lf%lf",&list[i][0].x,&list[i][0].y,&list[i][1].x,&list[i][1].y);
}

point pres(point st, point v, int i)
{
      point r;
      double t,s;
      t = st.x*(list[i][0].y-list[i][1].y) - st.y*(list[i][0].x-list[i][1].x);
      t += (list[i][0].x*list[i][1].y - list[i][0].y*list[i][1].x);
      s = v.x*(list[i][0].y-list[i][1].y) - v.y*(list[i][0].x-list[i][1].x);
      if (s <= 0.000001 && s>=-0.000001) return list[i][0];
      t = t/s;
      r.x = st.x -t*v.x;
      r.y = st.y -t*v.y;
      fl = (t>=0);
      return r;
}

inline double dist(point a, point b)
{return sqrt(SQR(a.x-b.x)+SQR(a.y-b.y));}

void solve(double ang)
{
     point st,v,p,q,bb,t;
     point v1,v2;
     int i,best;
     double l, u;
     used = 0;
     st = a;
     v.x = cos(ang); v.y = sin(ang);
     
     while (1) {
           best = -1; l = (1<<25);
           p.x = st.x+v.x; p.y = st.y+v.y;
           if (used == (1<<n)-1) {
              u = ori(st,p,b);
              if (u<0.0) u=-u;
              if (u < b_res) {b_res = u; b_ang = ang;}
              return;
              }
           for (i=0;i<n;++i) if (((used>>i)&1) == 0) if (ori(st,list[i][0],list[i][1]) >= 0.0) {
               if (ori(st,p,list[i][0]) * ori(st,p,list[i][1]) <= 0.0) {
                  q = pres(st,v,i);
                  u = dist(st,q);
                  if (!fl && u < l) {l = u;best = i;bb = q;}
                  }
               }
           if (best == -1) break;
           used |= (1<<best);
           v1 = v;
           v2.x = list[best][1].x - list[best][0].x;
           v2.y = list[best][1].y - list[best][0].y;
           norm(&v1); norm(&v2);
           u = v1.x*v2.x + v1.y*v2.y;
           v2.x *= u; v2.y *= u;
           v.x = 2.0*v2.x-v1.x;
           v.y = 2.0*v2.y-v1.y;
           norm(&v);
           st = bb;
           }
}

void opa()
{
     double A;
     for (A=0.0;A<2.0*M_PI;A+=0.000008) solve(A);
     //printf("ang=%lf d=%lf\n",b_ang*180.0/M_PI,b_res);
     if (b_res <= 0.0005) printf("YES\n%lf\n",b_ang*180.0/M_PI);
     else printf("NO\n");
}

int main()
{
    //int p,q;
    //p = clock();
    input();
    opa();
    //q = clock();
    //printf("time: %lf\n",(double)(q-p)/CLOCKS_PER_SEC);
    return 0;
}
