/*
TASK:mirrors
LANG:C++
*/
#include <cstdio>
#include <algorithm>

class pnt 
{
    public :
        pnt () {x = 0; y = 0;};
        pnt (double x_, double y_) {x = x_; y = y_;};
        bool operator < (pnt p1) {if (x == p1.x) return y < p1.y; else return x < p1.x;};
        bool operator >= (pnt p1) {if (x == p1.x) return y >= p1.y; else return x >= p1.x;};
        double x, y;
};
class vect
{
    public :
        vect () {};
        vect (pnt a_, pnt b_) {a = a_; b = b_;};
        pnt a, b;
        double dx() {return b.x - a.x;};
        double dy() {return b.y - a.y;};
};

int n;
pnt A, B;
vect v[16];
int used [16];
int order [16];

bool broken = false;

double scp(pnt a, vect p);
pnt crspnt (vect, vect);
pnt symetric (pnt, vect);
vect reflect (pnt, vect, vect);
vect perp (vect, pnt);
void perm (int, int);

int main () 
{
    scanf ("%d", &n);
    scanf ("%lf%lf", &(A.x), &(A.y));
    scanf ("%lf%lf", &(B.x), &(B.y));
    for (int i = 0; i < n; ++i)
        scanf ("%lf %lf %lf %lf", &(v[i].a.x), &(v[i].a.y), &(v[i].b.x), &(v[i].b.y));
    perm(0, 0);
    printf ("NO");
/*    pnt a(0, 0);
    pnt b(1, 0);
    pnt c(0, 1);
    pnt d(-1, 0);
    pnt e(0, -1);
    vect p (b, c);
    vect q (d, e);
    reflect (a, p, q);*/
    return 0;
}

double scp(pnt a, vect p)
{
    return (a.x-p.a.x)*p.dy() - (a.y-p.a.y)*p.dx();
}

pnt crspnt (vect p, vect q)
{
    double k = (q.dx()*(q.a.y - p.a.y) + q.dy()*(p.a.x - q.a.x))/(p.dy()*q.dx() - q.dy()*p.dx());
    pnt ret;
    ret.x = p.a.x + p.dx() * k;
    ret.y = p.a.y + p.dy() * k;
    return ret;
}

vect perp (vect p, pnt a)
{
    pnt c;
    if (scp(a, p) >= 0)
    {
        c.x = p.a.x - p.dy();
        c.y = p.a.y + p.dx();
    } else {
        c.x = p.a.x + p.dy();
        c.y = p.a.y - p.dx();
    }
    p.b = c;
    vect q = p;
    return p;
}

void perm (int lvl, int j)
{    
    if (lvl == 0)
    {
        for (int i = 0; i < n; ++i)
        {
            perm (1, i);
        }
        return;
    }
    used[j] = 1;
    order[lvl-1] = j;
    if (lvl == n) 
    {
        //work with it!
        vect nv = reflect (A, v[order[0]], v[order[1]]);
        if (broken)
        {
            broken = false;
        }
        else
        {
            for (int i = 0; i < n-2; ++i)
            ;
        }
    }
    else
    {
        for (int i = 0; i < n; ++i)
        {
            if (!used[i])
            {                
                perm (lvl + 1, i);
            }
        }
    }
    used[j] = 0;
}

pnt symetric (pnt a, vect p)
{
    vect q = perp(p, a);
    pnt c = q.a;
    q.a = q.b;
    q.b = c;
    c.x = a.x + q.dx();
    c.y = a.y + q.dy();
    q.a = a;
    q.b = c;
    pnt x = crspnt(q, p);
    pnt y (x.x + x.x - a.x, x.y + x.y - a.y);
    return y;
}

vect merge (vect p, vect q)
{
    vect res;
    pnt a = p.a, b = p.b, c = q.a, d = q.b, h;
    
    bool flipped = false;
    if (a >= b)
    {        
        h = a;
        a = b;
        b = h;
            h = c;
            c = d;
            d = h;   
        flipped = !flipped;  
    }
    if (d < a && a < b && b < c)
    {
        res.a = a;
        res.b = b;
    } else
    if (d < a && a < c && c < b)
    {
        res.a = a;
        res.b = c;
    } else
    if (a < d && d < b && b < c)
    {
        res.a = d;
        res.b = b;
    } else
    if (a < d && d < c && c < b)
    {
        res.a = d;
        res.b = c;
    } else
        broken = true;
    
    if (flipped)
    {
        h = res.a;
        res.a = res.b;
        res.b = h;
    }
    if ((c.x + c.y - d.x - d.y) * ( res.a.x + res.a.y - res.b.x - res.b.y) < 0)
    {
        h = res.a;
        res.a = res.b;
        res.b = h;
    }
    return res;               
}

vect reflect (pnt a, vect p, vect q)
{
    if (scp(a, p) > 0)
        broken = true;
    pnt a_ = symetric (a, p);
    vect a_b (a_, p.a);
    vect a_c (a_, p.b);
    pnt b_ = crspnt (a_b, q);
    pnt c_ = crspnt (a_c, q);
    vect b_c_ (b_, c_);      
    vect vb (p.a, b_);

    vect res = merge (b_c_, q);         
 
    return res;
}

